/*
Cdric Taschereau 05 658 674
Francis Corriveau 06 800 198

IFT 630 Projet
*/

//classe qui implante un tri rapide

import java.util.Random;

public class QuickSort extends GenericSorter {
	
	public QuickSort()
	{ }
	
	public String getName()
	{ return "QuickSort"; }
	
	public String getSorterType()
	{ return GenericSorter.QUICKSORT; }
	
	//mthode quicksort
	public RidiculouslyComplexObject[] doSort(RidiculouslyComplexObject[] data, int nbThreads)
	{
		RidiculouslyComplexObject[] left, right;
		
		if (data.length > 1)
		{
			int pivotNewIndex = partition(data);
			left = new RidiculouslyComplexObject[pivotNewIndex];
			right = new RidiculouslyComplexObject[data.length - pivotNewIndex - 1];
			
			for(int i = 0; i < pivotNewIndex; i++)
				left[i] = data[i];
			for(int i = pivotNewIndex + 1; i < data.length; i++)
				right[i - pivotNewIndex - 1] = data[i];
			
			SubArrays mySubArrays = new SubArrays(left, right);
			
			mySubArrays = sendToThreadAndSort(mySubArrays, nbThreads);
			
			for(int i = 0; i < data.length; i++)
			{
				if(i < pivotNewIndex)
					data[i] = mySubArrays.left[i];
				else if(i > pivotNewIndex)
					data[i] = mySubArrays.right[i - pivotNewIndex - 1];
			}
		}
			
		return data;
	}
	
	private int partition(RidiculouslyComplexObject[] data)
	{
		//obtenir un pivot random
		Random generator = new Random();
		int pivot = generator.nextInt(data.length);
		RidiculouslyComplexObject pivotObj = data[pivot];
		//RidiculouslyComplexObject pivotObj = data[0];
		int arrLen = data.length - 1;
		
		swap(data, pivot, arrLen); // Move pivot to end
		int storeIndex = 0;
		
		for(int i = 0; i < arrLen; i++)
		{
			if(data[i].isSmallerOrEqual(pivotObj))
			{
				swap(data, i, storeIndex);
				storeIndex++;
			}
		}
		
		swap(data, storeIndex, arrLen); // Move pivot to its final place
		
		return storeIndex;
	}
}