/*
Cdric Taschereau 05 658 674
Francis Corriveau 06 800 198

IFT 630 Projet
*/

//classe principale

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.FileInputStream;
import java.io.DataInputStream;

public class SorterMain {
	
	private DataInputStream in = null;
	private GenericSorter mySorter = null;
	private RidiculouslyComplexObject[] data;
	private int nbThreads = 1;
	
	//constructeur
	public SorterMain(String dataFileName, String sortType, int nbThreads)
	{
		try {
			//in = System.in;
			in = new DataInputStream(new FileInputStream(dataFileName));
			this.mySorter = GenericSorter.getSorter(sortType);
			this.nbThreads = nbThreads;
			this.getData();
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	public static void main(String[] args)
	{
		String dataFileName;
		String sortType = GenericSorter.MERGESORT;
		int nbThreads = 0;
		int nbExecutions = 1;
		long start, end;
		boolean printingOn = false;
		
		if(args.length == 1)
			System.exit(0);
		dataFileName = args[0];
		if(args.length >= 2)
			sortType = args[1];
		if(args.length >= 3)
			nbThreads = Integer.valueOf(args[2]);
		if(args.length >= 4)
			printingOn = Boolean.valueOf(args[3]);
		if(args.length >= 5)
			nbExecutions = Integer.valueOf(args[4]);
		
		SorterMain mainObj = null; //new SorterMain(sortType, nbThreads);
		
		if(nbThreads > 1)
			System.out.println("Starting " + GenericSorter.getSorter(sortType).getName() + " with " + nbThreads + " threads.");
		else
			System.out.println("Starting " + GenericSorter.getSorter(sortType).getName() + " with only one thread.");
		if(nbExecutions > 1)
			System.out.println("(Executing " + nbExecutions + " times.)");
			
		start = System.currentTimeMillis();
		
		for(int i = 0; i < nbExecutions; i++)
		{
			mainObj = new SorterMain(dataFileName, sortType, nbThreads);
			mainObj.sortData();
		}
		
		end = System.currentTimeMillis();
		System.out.println("DONE !");
		
		if(nbExecutions == 1)
			System.out.println("time : " + (end - start) + " milliseconds");
		else
			System.out.println("average time : " + ((end - start) / nbExecutions) + " milliseconds");
		
		if(printingOn)
			mainObj.printArray();
	}
	
	public void sortData()
	{
		data = mySorter.doSort(data, nbThreads);
	}
	
	//lit un fichier (habituellement) et construit un array d'int (tres complexes)
	public void getData()
	{
	
	/*
	File f;
    f=new File("myfile.txt");

      if(!f.exists()&& f.length()<0)
      System.out.println("The specified file is not exist");

      else{
         FileInputStream finp=new FileInputStream(f);
	*/
	
		try {
			BufferedReader myReader = new BufferedReader(new InputStreamReader(in));
			int arraySize = Integer.parseInt(myReader.readLine());
			data = new RidiculouslyComplexObject[arraySize];
			for(int i = 0; i < arraySize; i++)
				data[i] = new RidiculouslyComplexObject(Integer.valueOf(myReader.readLine()));
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	public void printArray()
	{
		for(int i = 0; i < data.length; i++)
			System.out.println(data[i].intValue);
	}

}
